//
// Created by Grigoriy Khlytin on 01.12.2021.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

vector<ll> f1(vector<ll> &s) {
    vector<ll> d1(s.size());
    ll n = (ll) s.size();
    ll l = 0, r = -1;
    for (ll i = 0; i < n; i++) {
        ll k = i > r ? 1 : min(d1[l + r - i], r - i + 1);
        while (i + k < n && i - k >= 0 && s[i + k] == s[i - k]) k++;
        d1[i] = k;
        if (i + k - 1 > r)
            l = i - k + 1, r = i + k - 1;
    }
    return d1;
}

vector<ll> f2(vector<ll> &s) {
    vector<ll> d2(s.size());
    ll n = (ll) s.size();
    ll l = 0, r = -1;
    for (ll i = 0; i < n; i++) {
        ll k = i > r ? 0 : min(d2[l + r - i + 1], r - i + 1);
        while (i + k < n && i - k - 1 >= 0 && s[i + k] == s[i - k - 1]) k++;
        d2[i] = k;
        if (i + k - 1 > r)
            l = i - k, r = i + k - 1;
    }
    return d2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;

    vector<ll> a(n);
    vector<ll> b(m);

    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (ll j = 0; j < m; j++) {
        cin >> b[j];
    }

    vector<ll> d1 = f1(a);
    vector<ll> d2 = f2(a);

    ll uneven_max = 0, even_max = 0;

    for (int i = 0; i < a.size(); i++) {
        uneven_max = max(uneven_max, 2 * d1[i] - 1);
    }

    for (int i = 0; i < a.size(); i++) {
        even_max = max(even_max, 2 * d2[i]);
    }

    if (m < uneven_max) {
        if (m % 2 != 0) {
            uneven_max = m;
        } else {
            uneven_max = m - 1;
        }
    }

    if (m < even_max) {
        if (m % 2 == 0) {
            even_max = m;
        } else {
            even_max = m - 1;
        }
    }

    cout << max(uneven_max, even_max);

    return 0;
}
