// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <stdio.h>
#include <bits/stdc++.h>
 
#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif
 
#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"
 
using ll = long long;
using ld = long double;
 
#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
 
template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
 
const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int P = 239;
const int MOD1 = (int)1e9 + 7;
const int MOD2 = 998244353;
const int N = 100100;
 
int add(int a, int b, int MOD) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}
 
int sub(int a, int b, int MOD) {
    if (a - b < 0) {
        return a - b + MOD;
    }
    return a - b;
}
 
int mul(int a, int b, int MOD) {
    return (int)(1ll * a * b % MOD);
}
 
int p1[N], p2[N];
 
void precalc() {
    p1[0] = 1;
    p2[0] = 1;
 
    for (int i = 1; i < N; ++i) {
        p1[i] = mul(p1[i - 1], P, MOD1);
        p2[i] = mul(p2[i - 1], P, MOD2);
    }
}
 
class Hash {
public:
    Hash() = default;
 
    void build(int* a) {
        h[0] = std::make_pair(a[0], a[0]);
        for (int i = 1; i < N; ++i) {
            h[i].first = add(mul(h[i - 1].first, P, MOD1), a[i], MOD1);
            h[i].second = add(mul(h[i - 1].second, P, MOD2), a[i], MOD2);
        }
    }
 
    std::pair<int, int> get(int l, int r) const {
        auto res = h[r];
        if (l != 0) {
            res.first = sub(res.first, mul(h[l - 1].first, p1[r - l + 1], MOD1), MOD1);
            res.second = sub(res.second, mul(h[l - 1].second, p2[r - l + 1], MOD2), MOD2);
        }
        return res;
    }
private:
    std::pair<int, int> h[N];
};
 
int a[N], b[N];
 
Hash hashA, hashB;
Hash revHashA, revHashB;
 
std::pair<int, int> getHash(const Hash& hasher, int l, int r) {
    return hasher.get(l, r);
}
 
std::pair<int, int> getRevHash(const Hash& hasher, int l, int r) {
    return hasher.get(N - r - 1, N - l - 1);
}
 
std::pair<int, int> diff(const std::pair<int, int>& h1, const std::pair<int, int>& h2) {
    return std::make_pair(sub(h1.first, h2.first, MOD1), sub(h1.second, h2.second, MOD2));
}
 
std::unordered_set<ll> setik;
// std::set<std::pair<int, int>> setik;
 
bool check(int n, int m, int len) {
    setik.clear();
 
    for (int i = 0; i + len - 1 < n; ++i) {
        int l = i, r = i + len - 1;
        auto curHash = getHash(hashA, l, r);
        auto curRevHash = getRevHash(revHashA, l, r);
        auto curDiff = diff(curHash, curRevHash);
        setik.insert(((ll)curDiff.first << 32) | curDiff.second);
        // setik.insert(curDiff);
 
        // std::cout << curDiff.first << ' ' << curDiff.second << std::endl;
    }
 
    for (int i = 0; i + len - 1 < m; ++i) {
        int l = i, r = i + len - 1;
        auto curHash = getHash(hashB, l, r);
        auto curRevHash = getRevHash(revHashB, l, r);
        auto curDiff = diff(curRevHash, curHash);
 
        // std::cout << curDiff.first << ' ' << curDiff.second << std::endl;
        if (setik.find(((ll)curDiff.first << 32) | curDiff.second) != setik.end()) {
            return true;
        }
        // if (setik.find(curDiff) != setik.end()) {
        //  return true;
        // }
    }
 
    return false;
}
 
void run() {
    precalc();
 
    int n, m;
    scanf("%d%d", &n, &m);
 
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
    }
    for (int i = 0; i < m; ++i) {
        scanf("%d", &b[i]);
    }
 
    hashA.build(a);
    hashB.build(b);
 
    std::reverse(a, a + N);
    std::reverse(b, b + N);
 
    revHashA.build(a);
    revHashB.build(b);
 
    int ans = 0;
    int l = 0, r = N;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int len = 2 * mid;
 
        if (len > n || len > m) {
            r = mid;
            continue;
        }
 
        if (check(n, m, len)) {
            l = mid;
        } else {
            r = mid;
        }
    }
 
    smax(ans, 2 * l);
 
    l = 0, r = N;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int len = 2 * mid + 1;
 
        if (len > n || len > m) {
            r = mid;
            continue;
        }
 
        if (check(n, m, len)) {
            l = mid;
        } else {
            r = mid;
        }
    }
 
    smax(ans, 2 * l + 1);
 
    printf("%d\n", ans);
}
 
int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);
 
    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();
 
    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif
 
    return 0;
}